package es.ehu.master2012;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StringReader;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

/**
 *
 * @author mpenagar & gbordel
 */

public class Util {

    	public static String getHTML(String url) throws MalformedURLException, IOException{
		StringBuilder sb = new StringBuilder();
		BufferedReader	in= new BufferedReader(new InputStreamReader(new URL(url).openStream()));
                String s;
		while ((s = in.readLine()) != null) sb.append(s);
		return sb.toString();
	}
	
	public static Stock[] getStocks(String url) throws MalformedURLException, IOException {
                String html=getHTML(url);
		List<Stock> list = new ArrayList<Stock>();
                String numero="<TD CLASS=\"DrillDownData\">(.*?)</TD>";
		Matcher m = Pattern.compile("<TR><TD CLASS=\"DrillDownDate\">(.*?)</TD>"+numero+numero+numero+numero+numero+"</TR>").matcher(html);
		while (m.find())
                list.add(new Stock(
                        m.group(1),
                        Float.parseFloat(m.group(2)),
                        Float.parseFloat(m.group(3)),
                        Float.parseFloat(m.group(4)),
                        Float.parseFloat(m.group(5)),
                        Integer.parseInt(m.group(6).replace(",",""))
                        ));
                return list.toArray(new Stock[0]);
	}
        
         public static String xmlTransform(String xml,String xsltFileName) throws TransformerConfigurationException, TransformerException{
                Transformer t=TransformerFactory.newInstance().newTransformer(new StreamSource(new File(xsltFileName)));
                Writer sw=new StringWriter();
                t.transform(new StreamSource(new StringReader(xml)), new StreamResult(sw));
                return sw.toString();
	}
	
}
